routes/web.php
<?php

use App\Http\Controllers\Admin\NewsController;
use App\Http\Controllers\Admin\ServicesController;
use App\Http\Controllers\Admin\AwardsController;

// use App\Http\Controllers\AwardsController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\MediaController;
use App\Http\Controllers\NewsController as ControllersNewsController;
use App\Http\Controllers\NProductController;
use App\Http\Controllers\ServiceController;
use App\Models\Banner;
use App\Models\Customer;
use App\Models\News;
use App\Models\Partner;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//website routes
Route::get('/test',function(){
    return view('test');
});
Route::get('/', function () {
    $banners = Banner::limit(10)->get();
    $categories = App\Models\Category::whereNull('parent_id')->get();
    $news =News::orderBy('created_at')->limit(4)->get();
    return view('welcome', compact('banners', 'categories','news'));
})->name('home');
Route::get('/about-us', function () {
    $partners = Partner::all();
    $customers = Customer::all();
    return view('about-us', compact('partners', 'customers'));
})->name('about.us');
Route::get('/business-lines/{category}', [CategoryController::class, 'show'])->name('category.show');
Route::get('/media', [MediaController::class, 'index'])->name('media.show');
Route::get('/product/{product}', [NProductController::class, 'show'])->name('wproduct.show');
Route::get('/news/{new}', [ControllersNewsController::class, 'show'])->name('newsa.show');
Route::get('/news', [ControllersNewsController::class, 'index'])->name('newsa.index');

Route::get('/services/{service}', [ServiceController::class, 'show'])->name('service.show');
Route::get('/awards', [AwardsController::class, 'index'])->name('awardsa.index');
Route::get('/contact-us', function () {
    return view('contact-us');
})->name('contact.us');
Route::post('/contact-us/store', function () {
    return redirect()->route('home');
})->name('contact.us.submit');

Route::get('/privacy', function () {
    return view('privacy');
})->name('privacy');


//admin routes
Route::group(
    ['prefix' => 'admin', 'namespace' => 'App\Http\Controllers\Admin'],
    function () {
        Route::group(['namespace' => 'Auth'], function () {
            Route::get('login', 'LoginController@showLoginForm')->name('login');
            Route::post('login', 'LoginController@login')->name('login_submit');
            Route::post('logout', 'LoginController@logout')->name('logout');
        });

        Route::group(['middleware' => ["auth"]], function () {
            Route::get('dashboard', 'DashboardController@index')->name('dashboard');
            //categories
            Route::resource('categories', 'CategoriesController')->except('create');
            //awards
            Route::resource('awards', 'AwardsController')->except('create');
            Route::post('categories/subadd/{parent}', 'CategoriesController@storesub')->name('categories.storesub');

            //vacancies
            Route::resource('vacancies', 'VacanciesController');
            Route::resource('requests', 'RequestsController');

            //users
            Route::resource('users', 'UsersController')->except('create');

            Route::resource('profile', 'ProfileController');

            Route::resource('news', 'NewsController');
            Route::resource('products', 'ProductsController');

            Route::get('products/preview_product/{id}', 'ProductsController@preview')->name('products.preview');

            Route::resource('services', 'ServicesController');
            Route::resource('partners', 'PartnersController');
            Route::resource('customers', 'CustomersController');


            Route::get('services/preview_services/{id}', ('ServicesController@preview'))->name('service.preview');



            Route::put('profile/{profile}/update_password', 'ProfileController@update_password')->name('profile.update_password');
        });
    }

);

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Kyslik\ColumnSortable\Sortable;
use Spatie\Activitylog\Traits\LogsActivity;

class Category extends SuperScope
{
    use HasFactory;
    use Sortable;

    protected $fillable = ['name', 'ar_name','fr_name', 'parent_id','description','ar_description','fr_description'];

    public $sortable = [
        'id',
        'name', 'ar_name','fr_name'
    ];
    public $sortableAs = ['childs_count'];

    public function parent()
    {
        return $this->belongsTo(\App\Models\Category::class, 'parent_id');
    }
    public function childs()
    {
        return $this->hasMany(\App\Models\Category::class, 'parent_id');
    }
    public function Products()
    {
        return $this->hasMany(Products::class);
    }
    public function services()
    {
        return $this->hasMany(Services::class);
    }
    public static function parents(){
        self::whereNull('parent_id');

    }
    public function getImageAttribute($value){
        if(!$value) return asset('covers/cover1.png');
        return asset('files/categories/images/'.$value);
    }
    public function getCoverAttribute($value){
        if(!$value) return asset('covers/cover2.png');
        return asset('files/categories/images/'.$value);
    }

}

app/Models/Vacancy.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Kyslik\ColumnSortable\Sortable;

class Vacancy extends SuperScope
{
    use HasFactory;
    use Sortable;


    protected $fillable = ['title', 'ar_title',  'fr_title','description', 'ar_description', 'fr_description', 'image', 'small_image'];

    public $sortable = [
        'id',
        'title', 'ar_title'
    ];
    public function getImageAttribute($value)
    {
        return asset('files/general/images/' . $value);
    }

    public function getSmallImageAttribute($value)
    {
        return asset('files/general/images/' . $value);
    }
}

app/Http/Controllers/Admin/VacanciesController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Misc\Helpers\FileHandler;
use App\Http\Requests\Admin\CreateNewVacancyRequest;

use App\Models\Vacancy;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;

class VacanciesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        //
        //check dates
        $data = Vacancy::dates($request->dates);
        $data = $data->sortable('id', 'desc')
            ->paginate(15)->withQueryString();;
        return view('admin.vacancies.index', compact('data'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *                                                                                                          
     * @param  \Illuminate\Http\Request  $request                               
     * @return \Illuminate\Http\Response                                            
     */
    public function store(CreateNewVacancyRequest $request)
    {
        //
        // $this->authorize('view-super', Auth::user());
        $record = Vacancy::create([
            "title" => $request->title,
            "ar_title" => $request->ar_title,
            "fr_title" => $request->fr_title,

            "description" => $request->description,
            "ar_description" => $request->ar_description,
            "fr_description" => $request->fr_description,

            "image" =>  FileHandler::store_img($request->image, 'general_images'),
            "small_image" =>  FileHandler::store_img($request->image, 'general_images'),
        ]);
        $record->save();

        return redirect()->back()->with(["message" => "تم اضافة فرصه عمل جديده"]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request,Vacancy $vacancy)
    {
        $vacancy->title = $request->title;
        $vacancy->ar_title = $request->ar_title;
        $vacancy->fr_title = $request->fr_title;
        $vacancy->description = $request->input('description' . $vacancy->id);
        $vacancy->ar_description = $request->input('ar_description' . $vacancy->id);
        $vacancy->fr_description = $request->input('fr_description' . $vacancy->id);
        if (empty($request->image)) {
        } else {
            $vacancy->image =  $request->file('image') ? FileHandler::store_img($request->image, 'general_images') : null;
        }
        if (empty($request->small_image)) {
        } else {
            $vacancy->small_image =  $request->file('small_image') ? FileHandler::store_img($request->small_image, 'general_images') : null;
        }


        $vacancy->save();
        return redirect()->back()->with(["message" => "You have update the vacancy information"]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request, Vacancy $vacancy)
    {
        $vacancy->delete();
        return redirect()->back()->with(["message" => 'Vacancy has been deleted']);
    }
}

resources/views/admin/vacancies/index.blade.php
@extends('layouts.dashboard')
@section('content')

    <x-content-header />
    <x-content-subheader>
        <x-button-add button class=" btn-primary " type="button" data-bs-toggle="modal" data-bs-target="#create-modal">
            Add new Job Vacancy
        </x-button-add>
        <x-modal id="create-modal" formid="createVacancy" method="post" action="{{ route('vacancies.store') }}">
            <x-slot name="header">Add new Job Vacancy</x-slot>
            <x-slot name="body">
                @include('admin._forms.create-vacancy')
            </x-slot>
        </x-modal>

    </x-content-subheader>
    <x-table title="Vacancies ">
        <x-slot name="header">
            <x-header-dates route="{{ route('vacancies.index') }}" />
        </x-slot>
        <x-slot name="tableheader">
            <tr>
                <th scope="col"></th>
                <th scope="col">@sortablelink('id', '#')</th>
                <th scope="col">@sortablelink('title','title ') </th>
                <th scope="col">@sortablelink('ar_title','ar title ') </th>
                <th scope="col">@sortablelink('fr_title','fr title ') </th>
                <th scope="col">Small Description</th>
                <th scope="col">Image</th>

            </tr>
        </x-slot>
        <x-slot name="tablebody">
            @foreach ($data as $row)
                <tr>
                    <th scope="row">
                        <x-operations>
                            <x-operation-button type="button" data-bs-toggle="modal"
                                data-bs-target="#view-modal-{{ $row->id }}">
                                View vacancy
                            </x-operation-button>
                            <x-operation-button type="button" data-bs-toggle="modal"
                                data-bs-target="#edit-modal-{{ $row->id }}">
                                edit vacancy
                            </x-operation-button>
                            <x-operation-button type="button" data-bs-toggle="modal"
                                data-bs-target="#delete-modal-{{ $row->id }}" class="delete-banner"
                                data-id="{{ $row->id }}" data-url="{{ route('vacancies.destroy', $row->id) }}">
                                delete vacancy
                            </x-operation-button>
                        </x-operations>


                    </th>
                    <td>{{ $row->id }}</td>
                    <td>{{ $row->title }}</td>
                    <td>{{ $row->ar_title }}</td>
                    <td>{{ $row->fr_title }}</td>
                    <td><a href="">
                            Show in website
                        </a>
                    </td>
                    <td><img width="65" src="{{ asset($row->image) }}" class="zoom"
                            alt="{{ $row->ar_title }}">
                    </td>
                </tr>
                <x-modal id="view-modal-{{ $row->id }}" method="get" role="document"
                    action="{{ route('products.show', $row->id) }}">
                    <x-slot name="header">View vacancy</x-slot>
                    <x-slot name="body">
                        @include('admin._forms.view-vacancy')
                    </x-slot>
                </x-modal>

                <x-modal id="edit-modal-{{ $row->id }}" method="put" role="document"
                    formid="Editvacancy{{ $row->id }}"  rowid="{{$row->id}}" 
                    action="{{ route('vacancies.update', $row->id) }}">
                    <x-slot name="header">Edit vacancy</x-slot>
                    <x-slot name="body">
                        @include('admin._forms.edit-vacancy')
                    </x-slot>
                </x-modal>

                <x-modal id="delete-modal-{{ $row->id }}" method="delete" role="document"
                    action="{{ route('vacancies.destroy', $row->id) }}">
                    <x-slot name="header">Do you want to delete this vacancy</x-slot>
                    <x-slot name="body">
                    </x-slot>
                </x-modal>
            @endforeach
        </x-slot>
        <x-slot name="tablefooter">
            <div class="d-flex justify-content-center mt-2  ">
                {{ $data->links('vendor.pagination.bootstrap-4') }}
            </div>
        </x-slot>
    </x-table>


@endsection



<style>
    .zoom {
        ransition: transform .2s;
        /* Animation */
        width: 65px;
        margin: 0 auto;
    }

    .zoom:hover {
        transform: scale(2.5);
        /* (150% zoom - Note: if the zoom is too large, it will go outside of the viewport) */
    }

</style>